/*
 * Copyright (C) 2003,2004 Intel Corporation. 
 * Copyright (C) 2004 Carl-Daniel Hailfinger. All rights reserved.
 *
 * dmraid extensions:
 * Copyright (C) 2004 Heinz Mauelshagen, Red Hat GmbH. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2.1, or (at your option)
 * any later version.
 *
 * You should have received a copy of the GNU General Public License
 * (for example /usr/src/linux/COPYING); if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Authors: Boji Tony Kannanthanam 
 *          < boji dot t dot kannanthanam at intel dot com >
 *          Martins Krikis
 *          < martins dot krikis at intel dot com >
 */

/*
 * FIXME: this needs more reengineering still.
 */

#ifndef _ISW_H_
#define _ISW_H_

#ifdef	FORMAT_HANDLER

/* Intel metadata offset in bytes */
#define	ISW_CONFIGOFFSET	((di->sectors - 2) << 9)
#define	ISW_DATAOFFSET		0	/* Data offset in sectors */

//                           "12345678901234567890123456789012"
#define MPB_SIGNATURE	     "Intel Raid ISM Cfg Sig. "
#define MPB_VERSION_RAID0                             "1.0.00"
#define MPB_VERSION_RAID1                             "1.1.00"
#define MPB_VERSION_RAID2                             "1.2.00"
#define MAX_SIGNATURE_LENGTH  32
#define MAX_RAID_SERIAL_LEN   16
#define ISW_DISK_BLOCK_SIZE  512
#define TYPICAL_MPBSIZE 1024

struct isw_RaidDev {
	int8_t	volume[MAX_RAID_SERIAL_LEN];
	uint32_t totalSize;
	uint32_t filler[24];
	uint32_t thisDevSize;
	uint32_t thisDevSize256;
	uint32_t stride;
} __attribute__((packed));

struct isw {
	uint8_t sig[MAX_SIGNATURE_LENGTH];/* 0x0 - 0x1F */
	uint32_t checkSum;		/* 0x20 - 0x23  MPB Checksum */
	uint32_t mpbSize;		/* 0x24 - 0x27 Size of MPB */
	uint32_t familyNum;		/* 0x28 - 0x2B Checksum from first time this config was written */
	uint32_t generationNum;	/* 0x2C - 0x2F  Incremented each time this array's MPB is written */
	uint32_t reserved[2];		/* 0x30 - 0x37 */
	uint8_t numDisks;		/* 0x38 Number of configured disks */
	uint8_t numRaidDevs;		/* 0x39 Number of configured volumes */
	uint8_t fill[2];		/* 0x3A - 0x3B */
	uint32_t filler[39];		/* 0x3C - 0xD7 RAID_MPB_FILLERS */
	struct isw_diskTbl {
		int8_t serial[MAX_RAID_SERIAL_LEN];/* 0xD8 - 0xE7 ascii serial number */
		uint32_t totalBlocks;	/* 0xE8 - 0xEB total blocks */
		uint32_t scsiId;	/* 0xEC - 0xEF scsi ID */
		uint32_t status;	/* 0xF0 - 0xF3 spare, configured, failed, useable, etc. */
		uint32_t filler[5];	/* 0xF4 - 0x107 MPB_DISK_FILLERS for future expansion */
	} diskTbl[1];	// diskTbl[numDisks]
	// here comes isw_RaidDev[numRaidDevs]
} __attribute__((packed));

/* Access to dynamic isw_RaidDev array */
static inline struct isw_RaidDev* raiddev(struct isw *isw)
{
	return (struct isw_RaidDev*) &isw->diskTbl[isw->numDisks];
}
#endif

int register_isw(void);

#endif
