/*
 * Copyright (C) 2004  Heinz Mauelshagen, Red Hat GmbH. All rights reserved.
 *
 * This dmraid library code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * dmraid is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this dmraid library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

#ifndef	_PDC_H_
#define	_PDC_H_

#ifdef	FORMAT_HANDLER

#include <stdint.h>

#define PDC_CONFIGOFFSET	di->geometry.sectors
#define	PDC_DATAOFFSET 0

/* Ondisk metadata for Promise Fastrack */
struct pdc {
#define PDC_ID_LENGTH	24
	uint8_t promise_id[PDC_ID_LENGTH];

	uint32_t unknown_0;
	uint32_t magic_0;
#define	PDC_MAGIC_0	0x00890605
	uint32_t unknown_1;
	uint32_t magic_1;
#define	PDC_MAGIC_1	0x04440605
	uint16_t unknown_2;
	uint8_t filler1[470];
	struct {
		uint32_t flags;	/* 0x200 */
		uint8_t unknown_0;
		uint8_t disk_number;
		uint8_t channel;
		uint8_t device;
		uint32_t magic_0;
		uint32_t unknown_1;
		uint32_t unknown_2;	/* 0x210 */
		uint32_t disk_secs;
		uint32_t unknown_3;
		uint16_t unknown_4;
		uint8_t status;
		uint8_t type;
#define	PDC_T_RAID_0	0x0
#define	PDC_T_RAID_1	0x1
#define	PDC_T_SPAN	0x8
		uint8_t total_disks;	/* 0x220 */
		uint8_t raid0_shift;
		uint8_t raid0_disks;
		uint8_t array_number;
		uint32_t total_secs;
		uint16_t cylinders;
		uint8_t heads;
		uint8_t sectors;
		uint32_t magic_1;
		uint32_t unknown_5;	/* 0x230 */
		struct pdc_disk {
			uint16_t unknown_0;
			uint8_t channel;
			uint8_t device;
			uint32_t magic_0;
			uint32_t disk_number;
		} disk[8];
	} raid;

	uint32_t filler2[346];
	uint32_t checksum;
} __attribute__ ((packed));

#define PDC_MAGIC        "Promise Technology, Inc."
#endif

int register_pdc(void);

#endif
