/*
 * Copyright (C) 2004  Heinz Mauelshagen, Red Hat GmbH. All rights reserved.
 *
 * This dmraid code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * dmraid is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this dmraid library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

/*
 * Profited from libparted.
 */

#ifndef	_MSDOS_H_
#define	_MSDOS_H_

#ifdef	FORMAT_HANDLER

#include <stdint.h>

#define	MSDOS_CONFIGOFFSET	0
#define	MSDOS_DATAOFFSET	0

struct chs {
        uint8_t         head;
        uint8_t         sector;
        uint8_t         cylinder;
} __attribute__((packed));

struct msdos_partition {
        uint8_t		boot_ind;	/* 00:  0x80 - active */
	struct chs	chs_start;	/* 01: */
	uint8_t		type;		/* 04: partition type */
#define PARTITION_EMPTY		0x00
#define PARTITION_EXT		0x05
#define PARTITION_EXT_LBA	0x0f
#define PARTITION_LINUX_EXT	0x85
#define PARTITION_GPT		0xee
	struct chs	chs_end;	/* 05: */
	uint32_t	start;		/* 08: starting sector from 0 */
	uint32_t	length;		/* 0c: nr of sectors in partition */
} __attribute__((packed));

struct msdos {
	uint8_t			boot_code [446];
	struct msdos_partition	partitions [4];
	uint16_t		magic;
#define	MSDOS_MAGIC	0xAA55
#define	PARTITION_MAGIC_MAGIC	0xF6F6
} __attribute__((packed));
#endif

enum PartitionType {
	PARTITION_NORMAL		= 0x00,
	PARTITION_LOGICAL		= 0x01,
	PARTITION_EXTENDED		= 0x02,
	PARTITION_FREESPACE		= 0x04,
	PARTITION_METADATA		= 0x08
};

/* Prototype of the register function for this metadata format handler */
int register_msdos(void);

#endif
